//****************************************************************************
//	
//	Copyright 2017 by WinSystems Inc.
//
//****************************************************************************
//
//	Name	 : pcmuio48DLL.h
//
//	Project	 : PCM-UIO48 Windows DLL
//
//	Author	 : Paul DeMetrotion
//
//****************************************************************************
//
//	  Date		  Rev	                Description
//	--------    -------	   ---------------------------------------------
//	08/15/17	  4.0		Original Release of DLL	
//
//****************************************************************************

#ifndef _PCMUIO48_DLL_H_
#define _PCMUIO48_DLL_H_

#if defined DLL_EXPORT
#define DECLDIR __declspec(dllexport)
#else
#define DECLDIR __declspec(dllimport)
#endif

extern "C"
{
    DECLDIR int InitializeSession(unsigned int device);
    DECLDIR int ResetDevice(unsigned int device);
    DECLDIR int SetIoMask(unsigned int device, unsigned int *portState);
    DECLDIR int GetIoMask(unsigned int device, unsigned int *portState);
    DECLDIR int ReadAllPorts(unsigned int device, unsigned int *readValueArray);
    DECLDIR int ReadPort(unsigned int device, int port, unsigned int *readValue);
    DECLDIR int ReadBit(unsigned int device, int bit, unsigned int *bitValue);
    DECLDIR int SetBit(unsigned int device, int bit);
    DECLDIR int ClearBit(unsigned int device, int bit);
    DECLDIR int WritePort(unsigned int device, int port, unsigned int writeValue);
    DECLDIR int WriteBit(unsigned int device, int bit, unsigned int bitValue);
    DECLDIR int EnableInterrupt(unsigned int device, int bit, int edge);
    DECLDIR int DisableInterrupt(unsigned int device, int bit);
    DECLDIR int GetInterrupt(unsigned int device, unsigned int *irqArray);
    DECLDIR int WaitForInterrupt(unsigned int device, unsigned int *irqArray, unsigned long timeout);
    DECLDIR int LockPort(unsigned int device, int port);
    DECLDIR int UnlockPort(unsigned int device, int port);
    DECLDIR int CloseSession(unsigned int device);
}

typedef enum {
    SUCCESS = 0,
    DRIVER_ERROR,
    ACCESS_ERROR,
    INVALID_HANDLE,
    INVALID_PARAMETER,
    TIMEOUT_ERROR
} ErrorCodes;

typedef enum {
    FALLING_EDGE = 0,
    RISING_EDGE
} IrqEdge;

#endif